<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Recherche de la page concernée
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT id, cle, titre, nom, bandeau, protection FROM pages');
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    // Si l'argument est donné sous la forme page=cle (pour admin.php, en POST)
    if ( isset($_REQUEST['page']) )
      $_REQUEST[$_REQUEST['page']] = '';
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $page = $r;
        $pid = $page['id'];
        break;
      }
  }
  // Page par défaut pour la partie publique : la première page
  if ( !isset($page) )  {
    // Page par défaut pour l'interface d'administration : admin.php
    if ( $admin )
      include('admin.php');
    $resultat->data_seek(0);
    $page = $resultat->fetch_assoc();
    $pid = $page['id'];
  }
  $resultat->free();
}
else
  include('installation.php');

///////////////////
// Modifications //
///////////////////
if ( ( $admin ) && isset($_REQUEST['titre']) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');
  
  // Traitement des modifications d'une information
  if ( isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {

    // Vérification que l'identifiant est valide. Défaut : id=0 (nouvelle information)
    if ( $id )  {
      $resultat = $mysqli->query("SELECT id, ordre, cache, titre, texte, ( SELECT MAX(ordre) FROM infos WHERE page = $pid ) AS max
                                  FROM infos WHERE page = $pid AND id = $id");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();
      }
      else
        $id = 0;
    }

    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('infos');

    // Pour les informations récentes
    $lien_recent = '.?'.addslashes($page['cle']);

    // Traitement d'un ajout/modification
    if ( isset($_REQUEST['modifie']) && strlen($_REQUEST['texte']) )  {

      // Validation des données envoyées
      $texte = $mysqli->real_escape_string($_REQUEST['texte']);
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);

      // Si $id > 0 : modification d'une information existante. Si $id = 0, nouvelle information
      if ( $id )  {
        if ( $mysqli->query("UPDATE infos SET texte = '$texte', titre = '$titre' WHERE id = $id") )  {
          $message = 'L\'information a bien été modifiée.';
          // Ajout d'une information récente si information diffusée
          if ( !$r['cache'] )
            recent($mysqli,1,$id,"<img class=\"icone\" src=\"icones/info.png\"> $titre",$lien_recent,$texte);
        }
        else
          $message = 'L\'information n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }
      else  {
        $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
        if ( $mysqli->query("UPDATE infos SET ordre = (ordre+1) WHERE page = $pid")
          && $mysqli->query("INSERT INTO infos SET ordre = 1, page = $pid, texte = '$texte', titre = '$titre', cache = $cache") )  {
            $message = 'L\'information a bien été ajoutée.';
            // Ajout d'une information récente si information diffusée
            if ( !$cache )
              recent($mysqli,1,$mysqli->insert_id,"<img class=\"icone\" src=\"icones/info.png\"> $titre",$lien_recent,$texte);
            $mysqli->query('ALTER TABLE infos ORDER BY page,ordre');
        }
        else
          $message = 'L\'information n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }

    elseif ( $id )  {

      // Déplacement vers le haut
      if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
        $message = ( $mysqli->query("UPDATE infos SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND page = $pid")
                  && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
        ) ? 'L\'information a bien été montée d\'une place.' : 'L\'information n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';

      // Déplacement vers le bas
      elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
        $message = ( $mysqli->query("UPDATE infos SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND page = $pid")
                  && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
        ) ? 'L\'information a bien été descendue d\'une place.' : 'L\'information n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';

      // Positionnement "montré" (apparaît sur la partie publique)
      elseif ( isset($_REQUEST['montre']) )  {
        if ( $mysqli->query("UPDATE infos SET cache = 0 WHERE id = $id") )  {
          $message = 'L\'information a bien été diffusée, elle apparaît désormais sur la partie publique.';
          // Ajout d'information récente
          recent($mysqli,1,$id,'<img class="icone" src="icones/info.png"> '.$mysqli->real_escape_string($r['titre']),$lien_recent,$mysqli->real_escape_string($r['texte']));
        }
        else
          $message = 'L\'information n\'a pas pu être diffusée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Positionnement "caché" (n'apparaît pas sur la partie publique)
      elseif ( isset($_REQUEST['cache']) )  {
        if ( $mysqli->query("UPDATE infos SET cache = 1 WHERE id = $id") )  {
          $message = 'L\'information n\'est plus diffusé&nbsp;: elle n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion.';
          // Suppression de l'éventuelle information récente
          recent($mysqli,1,$id);
        }
        else
          $message = 'L\'information n\'a pas pu être cachée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Suppression
      elseif ( isset($_REQUEST['supprime']) || !strlen($_REQUEST['texte']) )  {
        if ( $mysqli->query("DELETE FROM infos WHERE id = $id") 
          && $mysqli->query("UPDATE infos SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND page = $pid") )  {
          $message = 'L\'information a bien été supprimée.';
          // Suppression de l'éventuelle information récente
          recent($mysqli,1,$id);
        }
        else
          $message = 'L\'information n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
  }

  // Traitement des modifications de la page
  elseif ( isset($_REQUEST['modifie_page']) )  {
    if ( !strlen($_REQUEST['nom']) || !strlen($_REQUEST['cle']) )
      $message = 'Il n\'est pas possible de valider une page sans clé ou sans nom.';
    else  {
      // Vérifications des données envoyées
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $bandeau = $mysqli->real_escape_string($_REQUEST['bandeau']);
      $protection = ( isset($_REQUEST['protection']) ) ? 1 : 0;
      // Envoi des données
      $message = ( $mysqli->query("UPDATE pages SET nom = '$nom', titre = '$titre', cle = '$cle',
                                   bandeau = '$bandeau', protection = $protection WHERE id = $pid")
      ) ? 'Les données de la page ont bien été modifiées.' : 'Les données de la page n\'ont pas pu être modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      
      // Mise à jour des données de la page
      $resultat = $mysqli->query("SELECT cle, titre, nom, bandeau, protection FROM pages WHERE id = $pid");
      $page = $resultat->fetch_assoc();
      $resultat->free();
    }
  }

  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
}

//////////////
//// HTML ////
//////////////
$p = $page['cle'];
$t = $page['titre'];

// Interface d'administration
if ( $admin ) {

  // Haut de page, menu et message
  $t = "Modification de la page «&nbsp;${page['nom']}&nbsp;»";
  include('haut.php');

  // Aide générale  
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous modifier les préférences associées à la page et ajouter/modifier les informations qui s'y trouvent.</p>
    <h4>Préférences associées à la page</h4>
    <ul>
      <li>Le <em>titre</em> sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos de l'ADS et du TIPE&nbsp;».</li>
      <li>Le <em>nom dans le menu</em> est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations ADS/TIPE&nbsp;».</li>
      <li>La <em>clé</em> est un mot-clé qui est utilisé uniquement dans l'adresse de la page (<code>http://<?php echo $site; ?>/?[clé]</code>). Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;ads-tipe&nbsp;».</li>
      <li>Le <em>texte de début</em> sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum.</li>
    </ul>
    <p>La case à cocher <em>Demande d'identification pour l'affichage de la page </em> permet de restreindre la visibilité de la page aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
    <h4>Informations</h4>
    <p>Pour l'ajout d'information, la case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement cette information, par exemple pour la diffuser ultérieurement.</p>
    <p>Vous pouvez modifier le titre ou le texte d'une information existante, ou changer l'ordre d'apparition des différentes informations de la page.</p>
    <p>Vous pouvez <em>cacher</em> ou <em>montrer</em> une information existante, c'est-à-dire la diffuser ou non sur la partie publique.</p>
    <p>Vous pouvez supprimer une information existante par le bouton <em>Supprimer</em> ou en validant un texte vide.</p>
  </div>
  
<?php

  // Formulaire de modification des données de la page et formulaire d'ajout d'information
  $protection = ( $page['protection'] ) ? ' checked' : '';
  echo <<<FIN
  <div class="item admin">
  <form action="?$p$urladmin" method="post">
    <input class="bouton" type="submit" name="modifie_page" value="Valider">
    <h3>Modifier les préférences de la page</h3>
    <p class="ligne"><label for="titre">Titre&nbsp;: </label><input type="text" id="titre" name="titre" value="${page['titre']}" size="80"></p>
    <p class="ligne"><label for="nom">Nom dans le menu&nbsp;: </label><input type="text" id="nom" name="nom" value="${page['nom']}" size="50"></p>
    <p class="ligne"><label for="cle">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle" name="cle" value="${page['cle']}" size="30"></p>
    <p class="ligne"><label for="bandeau">Texte de début&nbsp;:</label></p>
    <textarea id="bandeau" name="bandeau" rows="2" cols="100">${page['bandeau']}</textarea>
    <p class="ligne"><label for="protection">Demande d'identification pour l'affichage de la page&nbsp;: </label><input type="checkbox" id="protection" name="protection" value="1"$protection></p>
  </form>
  </div>

  <div class="item admin">
  <form action="?$p$urladmin" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications de la page">
    <h3>Ajouter une nouvelle information</h3>
    <p class="transparent"><input class="ligne" type="text" name="titre" size=50 maxlength=65533 value="Titre de l'information"></p>
    <textarea name="texte" rows="10" cols="100">&lt;p&gt;Texte de l'information&lt;/p&gt;</textarea>
    <p class="ligne"><label for="cache">Ne pas diffuser sur la partie publique&nbsp;: </label><input type="checkbox" id="cache" name="cache" value="1"></p>
    <input type="hidden" name="id" value="0">
  </form>
  </div>

FIN;

  // Affichage des informations
  $resultat = $mysqli->query("SELECT id, ordre, cache, titre, texte FROM infos WHERE page = $pid");
  $mysqli->close();
  if ( $max = $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $monte = ( $r['ordre'] == 1 ) ? '' : "\n      <input type=\"submit\" name=\"monte\" value=\"&uarr;\" title=\"Remonter l'information dans l'ordre d'apparition\">";
      $descend = ( $r['ordre'] == $max ) ? '' : "\n      <input type=\"submit\" name=\"descend\" value=\"&darr;\" title=\"Descendre l'information dans l'ordre d'apparition\">";
      if ( $r['cache'] )  {
        $diff = ' (information non diffusée sur la partie publique)';
        $cache_classe = ' cache';
        $cache = "\n      <input type=\"submit\" name=\"montre\" value=\"Montrer\" title=\"Diffuser l'information, la rendre visible sur la partie publique\">";
      }
      else  {
        $cache_classe = $diff = '';
        $cache = "\n      <input type=\"submit\" name=\"cache\" value=\"Cacher\" title=\"Ne plus diffuser l'information, la rendre invisible sur la partie publique\">";
      }
      echo <<<FIN

  <div class="item admin$cache_classe">
  <form action="?$p$urladmin" method="post">
    <h3>Information n°${r['ordre']}&nbsp;: ${r['titre']}$diff</h3>
    <p class="boutons">
      <input type="submit" name="modifie" value="Valider" title="Valider les modifications sur le titre ou le texte">$monte$descend$cache
      <input type="submit" name="supprime" value="Supprimer" title="Supprimer l'information">
    </p>
    <p class="transparent"><input class="ligne" type="text" name="titre" size=50 maxlength=65533 value="${r['titre']}"></p>
    <textarea name="texte" rows="10" cols="100">${r['texte']}</textarea>
    <input type="hidden" name="id" value="${r['id']}">
  </form>
  </div>

FIN;
    }
    $resultat->free();
  }
  else
    echo "\n  <h2>Il n'y actuellement aucune information enregistrée pour cette page.</h2>\n\n";

  echo "\n  <script type=\"text/javascript\" src=\"textarea.js.php\"></script>\n\n";
}

// Partie publique
else  {

  // Demander l'identification si la page est protégée et l'utilisateur non connecté
  if ( $page['protection'] && !$lecteur )
    include('login_lecture.php');

  // Haut de page, menu et message
  include('haut.php');
  // Affichage des informations diffusées
  $resultat = $mysqli->query("SELECT titre, texte FROM infos WHERE page = $pid AND cache = 0");
  $mysqli->close();
  if ( $resultat->num_rows )  {
    echo "\n  <h2>${page['bandeau']}</h2>\n";
    while ( $r = $resultat->fetch_assoc() )
      echo <<<FIN

  <div class="item info">
    <h3>${r['titre']}</h3>
${r['texte']}
  </div>

FIN;
    $resultat->free();
  }
  else
    echo "  <h2>Cette page est actuellement vide.</h2>\n\n";
}

// Bas de page
include('bas.php');
?>
